<?php
echo "<!doctype>
<title>My Blog</title>
<style>
    body { margin: 0px; font-family: sans-serif; background-image: url(tile1.png) }
    .common { padding: 0em; border-radius: .3em}
    .hop:hover { position: relative; bottom: .2em }
    #main { padding: 1em 1em 1em 12em; width: 40em; margin: auto auto; height: auto; position: relative}
    .entry h1 { font-family: cursive; font-size: 1.3em; margin-top: 0px; margin-bottom: 0px }
    .entry { background-color: antiquewhite; margin-right: 5em; }
    .entry_text { padding: .5em; }
    .date  { width: 5em; float:right; background-color: antiquewhite; padding: .3em; }
    .date > div {
        width: 4em;
        float:right;
        text-align: center;
        color: white;
        text-transform: lowercase;
        font-weight: bold;
        background-color: black;
        padding: .3em;
        border-radius: .3em
        }
    .date > div > span { font-size: smaller }
    .title_br { border-right: 1px dashed; border-bottom: 1px dashed; border-bottom-right-radius: .3em; padding: 0px .3em }
    .image { width: 100px; }
    .image_left { margin-right: .5em; clear: left; margin-bottom: .5em }
    .image_right { margin-left: .5em; clear: right; margin-bottom: .5em}
    .image_left img:hover { border: 1em solid gray; border-radius: 1em; width: 450px; position: relative; top: 1em; left: 30px; }
    .image_right img:hover { border: 1em solid gray; border-radius: 1em; width: 450px; position: relative; top: 1em; right: 410px; }
    #posts { position: absolute; top: 1em; left: 1em; width: 10em; background-color: antiquewhite }
    #posts a { display: block; margin: 0.25em; text-align: center; }
    #posts a:link { color: black; text-decoration: none; border-bottom: 1px dotted silver }
    #posts a:visited { color: black; text-decoration: none }
    .top { text-align: right; padding: 0 1em .5em 0 }
    #posts h1 { font-weight: bold; font-size: 1.2em; text-align: center; font-family: sans-serif }
</style>";

process_entries();

function process_entries()
{
    echo "<div id=main>\n";
    
    $f = fopen("blog.txt", "r");
    $entry = 1;
    $posts = "";
    while (true) {
        $title = fgets($f);
        if (!$title)
            break;
        $title = trim($title);
        echo generate_date_div(fgets($f));
        echo "<div class='entry common'>\n";

        $link = "<a href=#entry_$entry>$title</a><br>";
        $posts = $link . $posts;
        
        $title = hop($title);
        echo "<h1 id=entry_$entry><span class=title_br>$title</span></h1>\n";
        echo "<div class=entry_text>\n";
        while ($line = fgets($f)) {
            $line = trim($line);
            if ($line == ".end")
                break;
            if ($line[0] == ".")
                echo process_dot_line($line);
            else
                echo "$line\n";
            }
        echo "</div>";
        echo "<div class=top><a href=#top>top</a></div>\n";
        echo "</div><br>\n";
        $entry += 1;
        }
        
    echo "<div id=posts class=common><h1>My Posts<br><small>(most recent first)</small></h1>$posts</div>\n";

    echo "</div>\n";
}
        
function hop($s)
{
    $result = "";
    for ($i = 0; $i < strlen($s); $i++) {
        $result .= "<span class=hop>$s[$i]</span>";
        }

    return $result;
}

function process_dot_line($line)
{
    if ($line == ".p") {
        return "<p>";
    } elseif ($line[2] == " ") { // .X ...
        $rest = substr($line, 3);
        return "<{$line[1]}>$rest</{$line[1]}>\n";
        }
    elseif ($line[3] == " ") {
        if ($line[1] == "r")
            $float = "right";
        else
            $float = "left";
        $src = substr($line, 4);
        return "<span class=image_$float style='display:inline;float:$float;width:100px;height:75px;border:1px solid'><img src=$src class='image'></span>";
        }
}

function generate_date_div($date)
{
    $months = "JanFebMarAprMayJunJulAugSepOctNovDec";

    $month = substr($months, (substr($date, 0, 2)-1)*3, 3);
    $day = ltrim(substr($date, 3, 2), "0");
    $year = "20" . substr($date, 6, 2);
    return "<div class='date common'><div>$month $day<br><span>$year<span></div></div>\n";
}
